package formes;

import java.awt.geom.Point2D;

abstract class FormeAbstraite implements Forme {

	private class Point2DInterne extends Point2D.Double {
		Point2DInterne(Point2D p) {
			super(p.getX(), p.getY());
		}
		
		public void setLocation(double x, double y) {
			messageBouger();
			super.setLocation(x, y);
		}
	}
	
	Point2D centreGravite;

	public FormeAbstraite(Point2D p) {
		centreGravite = new Point2DInterne(p);
	}

	private void messageBouger() {
		System.out.println("J'ai bougé !");
	}
	
	/* (non-Javadoc)
	 * @see formes.Forme#centreGravite()
	 */
	@Override
	public Point2D centreGravite() {
		return centreGravite;
	}

	/* (non-Javadoc)
	 * @see formes.Forme#perimetre()
	 */
	@Override
	public abstract double perimetre();

	/* (non-Javadoc)
	 * @see formes.Forme#surface()
	 */
	@Override
	public abstract double surface();

	/* (non-Javadoc)
	 * @see formes.Forme#placer(java.awt.geom.Point2D)
	 */
	@Override
	public void placer(Point2D nouveauCentreGravite) {
		centreGravite.setLocation(nouveauCentreGravite);
	}

	/* (non-Javadoc)
	 * @see formes.Forme#translater(double, double)
	 */
	@Override
	public void translater(double dx, double dy) {
		centreGravite.setLocation(centreGravite.getX() + dx, centreGravite.getY() + dy);
	}

	public String toString() {
		return getClass().getName() + " de centre (" + centreGravite.getX() + "," + centreGravite.getY() + ")";
	}
}